%------------------------------------------------------------------------
% Description: This code implements the paper: 
% "Image Segmentation with Cage Active Contours" Llus Garrido, Marit Guerrieri, Laura Igual
%
% Coded by: Llus Garrido and Laura Igual
%------------------------------------------------------------------------


function [seg,phi,its] = creaseg_CAC(img,init_mask,max_its)

    %parameters of the CAC method:
    dist=10;
    numpoints=16;
    band=600;
    
    % Save the initial mask of the experiment: al
    imwrite(init_mask, 'init_mask.pgm');
    imwrite(init_mask, 'init_mask.tiff');
    
    
    % Transform mask [0-1] to [0-255] and the image to uint8
    % Necessary for CAC code
    mask=uint8(zeros(size(init_mask)));
    mask(init_mask==1)=255;
    img=uint8(img);
    
    cd('code_CAC');
    % save original imgage:
    imwrite(img, 'img.pgm');
    
    [mask_out,its] = runCAC(mask, dist, numpoints, band);
    cd ..

    % Transform the coordinates into a final mask image:
    seg = zeros(size(mask_out));
    seg(mask_out<255)=1;
    % Transform the final mask image into a distance function:
    phi = seg;

end